
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : AT90USB1287
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Medium
;Optimize for           : Speed
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 2048 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME AT90USB1287
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 8192
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU WDTCSR=0x60
	.EQU UCSR1A=0xC8
	.EQU UDR1=0xCE
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __GETBRPF
	OUT  RAMPZ,R22
	ELPM R@0,Z
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "cnc.vec"
	.INCLUDE "cnc.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x2000)
	LDI  R25,HIGH(0x2000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
	LDI  R29,BYTE3(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	OUT  RAMPZ,R29
	ELPM R24,Z+
	ELPM R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	ELPM R26,Z+
	ELPM R27,Z+
	ELPM R0,Z+
	ELPM R1,Z+
	ELPM R28,Z+
	ELPM R29,Z+
	MOVW R22,R30
	IN   R29,RAMPZ
	MOVW R30,R0
	OUT  RAMPZ,R28
__GLOBAL_INI_LOOP:
	ELPM R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x20FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x20FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x900)
	LDI  R29,HIGH(0x900)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x900
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.25.9 Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.com
;       7 
;       8 Project : cnc
;       9 Version : 1.0
;      10 Date    : 16.02.2009
;      11 Author  : F4CG
;      12 Company : F4CG
;      13 Comments:
;      14 
;      15 
;      16 Chip type           : AT90USB1287
;      17 Program type        : Application
;      18 Clock frequency     : 16,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 2048
;      22 *****************************************************/
;      23 eeprom unsigned char debug=0;

	.ESEG
_debug:
	.DB  0x0
;      24 unsigned int tahometr=0;
;      25 //unsigned char current_ep=0;
;      26 //bit usb_connected=0;
;      27 unsigned char endpoints=3; // 0 - control; 1 - data in;  2 - data out.

	.DSEG
;      28 int i;
;      29 unsigned char usb_configuration_nb=1;
;      30 
;      31 #include <delay.h>
;      32 
;      33 #include <90usb1287.h>
;      34 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      35 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      36 	.EQU __se_bit=0x01
	.EQU __se_bit=0x01
;      37 	.EQU __sm_mask=0x0E
	.EQU __sm_mask=0x0E
;      38 	.EQU __sm_powerdown=0x04
	.EQU __sm_powerdown=0x04
;      39 	.EQU __sm_powersave=0x06
	.EQU __sm_powersave=0x06
;      40 	.EQU __sm_standby=0x0C
	.EQU __sm_standby=0x0C
;      41 	.EQU __sm_ext_standby=0x0E
	.EQU __sm_ext_standby=0x0E
;      42 	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_adc_noise_red=0x02
;      43 	.SET power_ctrl_reg=smcr
	.SET power_ctrl_reg=smcr
;      44 	#endif
	#endif
;      45 #include <usbdefines.h>

	.CSEG
_wSWAP:
;	x -> Y+0
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	MOVW R26,R30
	LD   R31,Y
	LDI  R30,LOW(0)
	OR   R30,R26
	OR   R31,R27
	ADIW R28,2
	RET

	.DSEG
_usbs:
	.BYTE 0x8
_usb_device_descriptor:
_0usb_device_descriptor:
	.BYTE 0x1
_1usb_device_descriptor:
	.BYTE 0x1
_2usb_device_descriptor:
	.BYTE 0x2
_3usb_device_descriptor:
	.BYTE 0x1
_4usb_device_descriptor:
	.BYTE 0x1
_5usb_device_descriptor:
	.BYTE 0x1
_6usb_device_descriptor:
	.BYTE 0x1
_7usb_device_descriptor:
	.BYTE 0x2
_8usb_device_descriptor:
	.BYTE 0x2
_9usb_device_descriptor:
	.BYTE 0x2
_Ausb_device_descriptor:
	.BYTE 0x1
_Busb_device_descriptor:
	.BYTE 0x1
_Cusb_device_descriptor:
	.BYTE 0x1
_Dusb_device_descriptor:
	.BYTE 0x1
_usb_configuration:
_0usb_configuration:
	.BYTE 0x1
_1usb_configuration:
	.BYTE 0x1
_2usb_configuration:
	.BYTE 0x2
_3usb_configuration:
	.BYTE 0x1
_4usb_configuration:
	.BYTE 0x1
_5usb_configuration:
	.BYTE 0x1
_6usb_configuration:
	.BYTE 0x1
_7usb_configuration:
	.BYTE 0x1
_9usb_configuration:
	.BYTE 0x1
_Ausb_configuration:
	.BYTE 0x1
_Busb_configuration:
	.BYTE 0x1
_Cusb_configuration:
	.BYTE 0x1
_Dusb_configuration:
	.BYTE 0x1
_Eusb_configuration:
	.BYTE 0x1
_Fusb_configuration:
	.BYTE 0x1
_10usb_configuration:
	.BYTE 0x1
_11usb_configuration:
	.BYTE 0x1
_usb_language:
_0usb_language:
	.BYTE 0x1
_1usb_language:
	.BYTE 0x1
_2usb_language:
	.BYTE 0x2
_usb_manufacturer:
_0usb_manufacturer:
	.BYTE 0x1
_1usb_manufacturer:
	.BYTE 0x1
_2usb_manufacturer:
	.BYTE 0xA
_usb_product:
_0usb_product:
	.BYTE 0x1
_1usb_product:
	.BYTE 0x1
_2usb_product:
	.BYTE 0x16
_usb_serial_number:
_0usb_serial_number:
	.BYTE 0x1
_1usb_serial_number:
	.BYTE 0x1
_2usb_serial_number:
	.BYTE 0x6
;      46 #include <usblib.h>

	.CSEG
_unfreeze_clk:
	LDS  R30,216
	ANDI R30,0xDF
	STS  216,R30
	RET
_wait_pll_ready:
_0x29:
	IN   R30,0x29
	ANDI R30,LOW(0x1)
	CALL __LNEGB1
	CPI  R30,LOW(0x1)
	BRSH _0x29
	RET
_pll_start:
	IN   R30,0x29
	ORI  R30,2
	OUT  0x29,R30
	RET
_Usb_clear_rx:
	RET
_set_direct_endpoint:
;	num -> Y+0
	LDS  R30,236
	ANDI R30,0xFE
	STS  236,R30
	LDS  R30,236
	LD   R26,Y
	OR   R30,R26
	STS  236,R30
	RJMP _0xC9
_Usb_rx_complete:
	LDS  R30,232
	ANDI R30,LOW(0x4)
	CPI  R30,LOW(0x1)
	BRLO _0x2C
	LDI  R30,LOW(1)
	RET
_0x2C:
	LDI  R30,LOW(0)
	RET
	RET
_Usb_setup_received:
	ST   -Y,R17
;	otv -> R17
	LDI  R17,LOW(0)
	LDS  R30,232
	ANDI R30,LOW(0x8)
	BREQ _0x2E
	LDI  R17,LOW(1)
_0x2E:
	MOV  R30,R17
	RJMP _0xC8
_Usb_tx_complete:
	LDS  R30,232
	ANDI R30,LOW(0x1)
	CPI  R30,LOW(0x1)
	BRLO _0x2F
	LDI  R30,LOW(1)
	RET
_0x2F:
	LDI  R30,LOW(0)
	RET
	RET
_set_endpoint:
;	num -> Y+0
	LDS  R30,233
	CLR  R31
	CLR  R22
	CLR  R23
	__ANDD1N 0x11111000
	STS  233,R30
	LDS  R30,233
	LD   R26,Y
	OR   R30,R26
	STS  233,R30
	RJMP _0xC9
_Usb_read_byte:
	LDS  R30,241
	RET
_usb_write_byte:
;	b -> Y+0
	LD   R30,Y
	STS  241,R30
	RJMP _0xC9
_usb_clear_rx_setup:
	LDS  R30,232
	ANDI R30,0XF7
	STS  232,R30
	RET
_usb_set_stall_request:
	LDS  R30,235
	ORI  R30,0x20
	STS  235,R30
	RET
_usb_clear_stall_request:
	LDS  R30,235
	ANDI R30,LOW(0x20)
	STS  235,R30
	RET
_usb_clear_stalled:
	LDS  R30,232
	ANDI R30,0xFD
	STS  232,R30
	RET
_WaitForOutZeroPacket:
_0x31:
	RCALL _Usb_rx_complete
	CPI  R30,LOW(0x1)
	BRLO _0x34
	RCALL _Usb_setup_received
	MOV  R26,R30
	CPI  R26,0
	BREQ _0x33
_0x34:
	RJMP _0x31
_0x33:
	RCALL _Usb_clear_rx
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	RET
_usb_stall_sent:
	LDS  R30,232
	ANDI R30,LOW(0x2)
	RET
_Usb_set_tx_ready:
	LDS  R30,232
	ANDI R30,0x7F
	STS  232,R30
	RET
_SendDataFromFIFO:
	RCALL _Usb_set_tx_ready
_0x36:
	RCALL _Usb_tx_complete
	CPI  R30,0
	BREQ _0x36
	RET
_usb_send_ep0_packet:
	CALL __SAVELOCR4
;	*tbuf -> Y+5
;	data_length -> Y+4
;	*bbuf -> R16,R17
;	iii -> R19
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _set_endpoint
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	__GETWRS 16,17,5
	LDI  R19,LOW(0)
_0x3A:
	LDD  R30,Y+4
	CP   R19,R30
	BRSH _0x3B
	MOVW R26,R16
	LD   R30,X
	ST   -Y,R30
	RCALL _usb_write_byte
	__SUBWRN 16,17,1
	SUBI R19,-1
	RJMP _0x3A
_0x3B:
	RCALL _Usb_set_tx_ready
	MOVW R30,R16
	CALL __LOADLOCR4
	ADIW R28,7
	RET
_GetConfiguration:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	LDI  R30,LOW(1)
	MOV  R5,R30
	ST   -Y,R5
	RCALL _usb_write_byte
	RCALL _SendDataFromFIFO
	RCALL _WaitForOutZeroPacket
	RET
_STALL:
	RCALL _usb_clear_rx_setup
	RCALL _usb_set_stall_request
_0x3C:
	RCALL _usb_stall_sent
	CPI  R30,0
	BREQ _0x3C
	RCALL _usb_clear_stall_request
	RCALL _usb_clear_stalled
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	RET
_SendInZeroPacket:
	RCALL _SendDataFromFIFO
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	RET
_SetConfiguration:
	ST   -Y,R17
;	configuration_number -> R17
	__GETBRMN 17,_usbs,2
	CPI  R17,2
	BRSH _0x3F
	MOV  R5,R17
	RJMP _0x40
_0x3F:
	RCALL _STALL
	RJMP _0xC8
_0x40:
	RCALL _SendInZeroPacket
	RJMP _0xC8
_Usb_clear_tx_complete:
	RET
_Usb_clear_tx_ready:
	RET
_Usb_set_FADDEN:
	LDS  R30,227
	ORI  R30,0x80
	STS  227,R30
	RET
_GetDescriptor:
	PUSH R15
	CALL __SAVELOCR6
;	data_to_transfer -> R17
;	wLength -> R18,R19
;	zlp -> R15.0
;	*pbuffer -> R20,R21
	__GETB1MN _usbs,3
;	zlp -> R15.0
	CPI  R30,LOW(0x1)
	BRNE _0x44
;	zlp -> R15.0
	LDI  R17,LOW(18)
	__POINTWRM 20,21,_usb_device_descriptor
	RJMP _0x43
_0x44:
	CPI  R30,LOW(0x2)
	BRNE _0x45
;	zlp -> R15.0
	LDI  R17,LOW(18)
	__POINTWRM 20,21,_usb_configuration
	RJMP _0x43
_0x45:
	CPI  R30,LOW(0x3)
	BRNE _0x4F
;	zlp -> R15.0
	__GETB1MN _usbs,2
;	zlp -> R15.0
	CPI  R30,0
	BRNE _0x4A
;	zlp -> R15.0
	LDI  R17,LOW(4)
	__POINTWRM 20,21,_usb_language
	RJMP _0x49
_0x4A:
	CPI  R30,LOW(0x1)
	BRNE _0x4B
;	zlp -> R15.0
	LDI  R17,LOW(12)
	__POINTWRM 20,21,_usb_manufacturer
	RJMP _0x49
_0x4B:
	CPI  R30,LOW(0x2)
	BRNE _0x4C
;	zlp -> R15.0
	LDI  R17,LOW(24)
	__POINTWRM 20,21,_usb_product
	RJMP _0x49
_0x4C:
	CPI  R30,LOW(0x3)
	BRNE _0x4E
;	zlp -> R15.0
	LDI  R17,LOW(8)
	__POINTWRM 20,21,_usb_serial_number
	RJMP _0x49
_0x4E:
;	zlp -> R15.0
	RCALL _STALL
	RJMP _0xCA
_0x49:
	RJMP _0x43
_0x4F:
;	zlp -> R15.0
	RCALL _STALL
	RJMP _0xCA
;	zlp -> R15.0
;	zlp -> R15.0
;	zlp -> R15.0
_0xCB:
	BLD  R15,0
;	zlp -> R15.0
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _set_direct_endpoint
_0x54:
	CPI  R17,33
	BRLO _0x56
;	zlp -> R15.0
	ST   -Y,R21
	ST   -Y,R20
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _usb_send_ep0_packet
	MOVW R20,R30
	SUBI R17,LOW(32)
	RCALL _Usb_set_tx_ready
_0x57:
	RCALL _Usb_rx_complete
	MOV  R26,R30
	CPI  R26,0
	BRNE _0x5A
	RCALL _Usb_tx_complete
	MOV  R26,R30
	CPI  R26,0
	BREQ _0x5B
_0x5A:
	RJMP _0x59
_0x5B:
	RJMP _0x57
_0x59:
	RCALL _Usb_clear_tx_complete
	RCALL _Usb_rx_complete
	CPI  R30,0
	BREQ _0x5C
;	zlp -> R15.0
	RCALL _Usb_clear_tx_ready
	RCALL _Usb_clear_rx
	RJMP _0xCA
_0x5C:
	RJMP _0x54
_0x56:
	ST   -Y,R21
	ST   -Y,R20
	ST   -Y,R17
	RCALL _usb_send_ep0_packet
	MOVW R20,R30
	LDI  R17,LOW(0)
	RCALL _Usb_set_tx_ready
_0x5D:
	RCALL _Usb_rx_complete
	MOV  R26,R30
	CPI  R26,0
	BRNE _0x60
	RCALL _Usb_tx_complete
	MOV  R26,R30
	CPI  R26,0
	BREQ _0x61
_0x60:
	RJMP _0x5F
_0x61:
	RJMP _0x5D
_0x5F:
	RCALL _Usb_clear_tx_complete
	RCALL _Usb_rx_complete
	CPI  R30,0
	BREQ _0x62
;	zlp -> R15.0
	RCALL _Usb_clear_tx_ready
	RCALL _Usb_clear_rx
	RJMP _0xCA
_0x62:
	SBRS R15,0
	RJMP _0x63
;	zlp -> R15.0
	RCALL _Usb_set_tx_ready
_0x64:
	RCALL _Usb_rx_complete
	CPI  R30,0
	BRNE _0x67
	RCALL _Usb_tx_complete
	CPI  R30,0
	BREQ _0x68
_0x67:
	RJMP _0x66
_0x68:
	RJMP _0x64
_0x66:
	RCALL _Usb_clear_tx_complete
	RCALL _Usb_rx_complete
	CPI  R30,0
	BREQ _0x69
;	zlp -> R15.0
	RCALL _Usb_clear_tx_ready
	RCALL _Usb_clear_rx
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	RJMP _0xCA
_0x69:
_0x63:
_0x6A:
	RCALL _Usb_rx_complete
	CPI  R30,0
	BRNE _0x6D
	RCALL _Usb_setup_received
	CPI  R30,0
	BREQ _0x6E
_0x6D:
	RJMP _0x6C
_0x6E:
	RJMP _0x6A
_0x6C:
	RCALL _Usb_setup_received
	CPI  R30,0
	BRNE _0xCA
;	zlp -> R15.0
	RCALL _Usb_rx_complete
	CPI  R30,0
	BREQ _0x70
;	zlp -> R15.0
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	RCALL _Usb_clear_rx
_0x70:
_0x43:
_0xCA:
	CALL __LOADLOCR6
	ADIW R28,6
	POP  R15
	RET
_GetStatusDevice:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _usb_write_byte
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _usb_write_byte
	RCALL _SendDataFromFIFO
	RCALL _WaitForOutZeroPacket
	RET
_GetStatusInterf:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _usb_write_byte
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _usb_write_byte
	RCALL _SendDataFromFIFO
	RCALL _WaitForOutZeroPacket
	RET
_GetStatusEndpoint:
	ST   -Y,R17
;	wIndex -> R17
	__GETB1MN _usbs,4
	ANDI R30,0x7F
	MOV  R17,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _set_direct_endpoint
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _usb_write_byte
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _usb_write_byte
	RCALL _SendDataFromFIFO
	RCALL _WaitForOutZeroPacket
	RJMP _0xC8
_Usb_configure_address:
;	ad -> Y+0
	LD   R30,Y
	ANDI R30,0x7F
	STS  227,R30
_0xC9:
	ADIW R28,1
	RET
_SetAddress:
	RCALL _Usb_set_FADDEN
	RCALL _SendInZeroPacket
	__GETB1MN _usbs,2
	ST   -Y,R30
	RCALL _Usb_configure_address
	RET
_UsbControlPacketProcessed:
	ST   -Y,R17
;	ii -> R17
	LDI  R17,LOW(0)
_0x72:
	CPI  R17,8
	BRSH _0x73
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_usbs)
	SBCI R31,HIGH(-_usbs)
	PUSH R31
	PUSH R30
	RCALL _Usb_read_byte
	POP  R26
	POP  R27
	ST   X,R30
	SUBI R17,-1
	RJMP _0x72
_0x73:
	__GETB1MN _usbs,3
	CPI  R30,LOW(0x8000)
	BRNE _0x77
	RCALL _GetStatusDevice
	RJMP _0x76
_0x77:
	CPI  R30,LOW(0x8100)
	BRNE _0x78
	RCALL _GetStatusInterf
	RJMP _0x76
_0x78:
	CPI  R30,LOW(0x8200)
	BRNE _0x79
	RCALL _GetStatusEndpoint
	RJMP _0x76
_0x79:
	CPI  R30,LOW(0x8006)
	BREQ _0x7B
	CPI  R30,LOW(0x8106)
	BRNE _0x7C
_0x7B:
	RJMP _0x7D
_0x7C:
	CPI  R30,LOW(0x8206)
	BRNE _0x7E
_0x7D:
	RCALL _GetDescriptor
	RJMP _0x76
_0x7E:
	CPI  R30,LOW(0x8008)
	BRNE _0x7F
	RCALL _GetConfiguration
	RJMP _0x76
_0x7F:
	CPI  R30,LOW(0x9)
	BRNE _0x80
	RCALL _SetConfiguration
	RJMP _0x76
_0x80:
	CPI  R30,LOW(0x5)
	BRNE _0x82
	RCALL _SetAddress
	RJMP _0x76
_0x82:
	RCALL _STALL
_0x76:
	RJMP _0xC8
_usb_attach:
	LDS  R30,224
	ANDI R30,0xFE
	STS  224,R30
	RET
;	num -> Y+0
;	num -> Y+0
_data_recieve:
	ST   -Y,R17
;	otv -> R17
	LDS  R30,232
	ANDI R30,LOW(0x4)
	BREQ _0x95
	LDI  R17,LOW(3)
_0x95:
	MOV  R30,R17
	LDI  R31,0
_0xC8:
	LD   R17,Y+
	RET
_Usb_enable_suspend_interrupt:
	LDS  R30,226
	ORI  R30,1
	STS  226,R30
	RET
_Usb_enable_reset_interrupt:
	LDS  R30,226
	ORI  R30,8
	STS  226,R30
	RET
_init_ep0:
	LDI  R30,LOW(0)
	STS  233,R30
	LDI  R30,LOW(1)
	STS  235,R30
	LDI  R30,LOW(0)
	STS  236,R30
	LDI  R30,LOW(32)
	STS  237,R30
	LDS  R30,237
	ORI  R30,2
	STS  237,R30
	LDS  R30,234
	ORI  R30,1
	STS  234,R30
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDS  R30,234
	ANDI R30,0xFE
	STS  234,R30
	LDS  R30,238
	ANDI R30,LOW(0x80)
	BRNE _0x97
	SBI  0x11,4
_0x97:
	RET
_usb_start_device:
	LDS  R30,216
	ANDI R30,LOW(0x3F)
	STS  216,R30
	LDS  R30,215
	ORI  R30,1
	STS  215,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(20)
	OUT  0x29,R30
	RCALL _pll_start
	RCALL _wait_pll_ready
	LDI  R30,LOW(4)
	STS  224,R30
	LDS  R30,215
	ORI  R30,0x80
	STS  215,R30
	LDS  R30,215
	ANDI R30,LOW(0xAF)
	STS  215,R30
	LDS  R30,216
	ORI  R30,0x10
	STS  216,R30
	LDS  R30,216
	ORI  R30,LOW(0xA0)
	STS  216,R30
	RCALL _unfreeze_clk
	LDI  R30,LOW(0)
	STS  226,R30
	STS  232,R30
	RET
_recieve_reset:
	LDS  R30,225
	ANDI R30,LOW(0x8)
	BREQ _0x9A
	LDI  R30,LOW(223)
	STS  240,R30
	LDI  R30,LOW(7)
	STS  234,R30
	LDI  R30,LOW(0)
	STS  234,R30
	LDS  R30,226
	ORI  R30,4
	STS  226,R30
	LDS  R30,225
	ANDI R30,0XF7
	STS  225,R30
	LDI  R30,LOW(0)
	STS  225,R30
	STS  233,R30
_0x9A:
	RET
_recieve_setup:
	LDS  R30,232
	ANDI R30,LOW(0x28)
	BREQ _0x9B
	LDS  R30,232
	ANDI R30,0XF7
	STS  232,R30
	SBI  0x11,4
	RCALL _UsbControlPacketProcessed
_0x9B:
	RET
_recieve_sof:
	LDS  R30,225
	ANDI R30,LOW(0x4)
	BREQ _0x9E
	LDS  R30,225
	ANDI R30,0xFB
	STS  225,R30
_0x9E:
	RET
;      47 
;      48 
;      49 interrupt [USB_ENDPOINT_PIPE] void usb_endpoint_isr(void)
;      50 {
_usb_endpoint_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,RAMPZ
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      51 
;      52    PORTF.4=1;
	SBI  0x11,4
;      53 if (UDINT & 1)
	LDS  R30,225
	ANDI R30,LOW(0x1)
	BREQ _0xA1
;      54    {
;      55    PORTF.4=1;
	SBI  0x11,4
;      56    // Suspend interrupt
;      57 
;      58    }
;      59 if (UDINT & 4)
_0xA1:
	LDS  R30,225
	ANDI R30,LOW(0x4)
	BREQ _0xA4
;      60    {
;      61       PORTF.4=1;
	SBI  0x11,4
;      62 
;      63    if ((Usb_setup_received()>0) && (i == 0)) {UsbControlPacketProcessed();};
	RCALL _Usb_setup_received
	CPI  R30,LOW(0x1)
	BRLO _0xA8
	CLR  R0
	CP   R0,R7
	CPC  R0,R8
	BREQ _0xA9
_0xA8:
	RJMP _0xA7
_0xA9:
	RCALL _UsbControlPacketProcessed
_0xA7:
;      64         if (data_recieve()>0) {;};
	RCALL _data_recieve
	MOVW R26,R30
	CALL __CPW02
	BRGE _0xAA
_0xAA:
;      65    }
;      66 if (UDINT & 8)
_0xA4:
	LDS  R30,225
	ANDI R30,LOW(0x8)
	BREQ _0xAB
;      67    {
;      68     PORTF.4=1;
	SBI  0x11,4
;      69    // End Of Reset interrupt
;      70   //enable_ep_interrupt(); // Place your code here
;      71    }
;      72 if (UDINT & 0x10)
_0xAB:
	LDS  R30,225
	ANDI R30,LOW(0x10)
	BREQ _0xAE
;      73    {
;      74    // Wake-up CPU interrupt
;      75   PORTF.4=1; // Place your code here
	SBI  0x11,4
;      76    }
;      77 if (UDINT & 0x20)
_0xAE:
	LDS  R30,225
	ANDI R30,LOW(0x20)
	BREQ _0xB1
;      78    {
;      79 
;      80    // End Of Resume interrupt
;      81    // Place your code here
;      82    }
;      83 if (UDINT & 0x40)
_0xB1:
	LDS  R30,225
	ANDI R30,LOW(0x40)
	BREQ _0xB2
;      84    {
;      85 
;      86  PORTF.4=1;
	SBI  0x11,4
;      87    // Upstream Resume interrupt
;      88    // Place your code here
;      89    }
;      90 UDINT=0; // Clear the interrupt flags
_0xB2:
	LDI  R30,LOW(0)
	STS  225,R30
;      91 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	OUT  RAMPZ,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;      92 
;      93 
;      94 
;      95 
;      96 interrupt [USB_GENERAL] void usb_general_isr(void)
;      97 {
_usb_general_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      98 
;      99 if (USBINT & 1)
	LDS  R30,218
	ANDI R30,LOW(0x1)
	BREQ _0xB5
;     100    {
;     101 
;     102    }
;     103 if (USBINT & 2)
_0xB5:
	LDS  R30,218
	ANDI R30,LOW(0x2)
	BREQ _0xB6
;     104    {
;     105    // ID Transition interrupt
;     106    // Place your code here
;     107    }
;     108 USBINT=0; // Clear the interrupt flags
_0xB6:
	LDI  R30,LOW(0)
	STS  218,R30
;     109 if (OTGINT & 1)
	LDS  R30,223
	ANDI R30,LOW(0x1)
	BREQ _0xB7
;     110    {
;     111    // SRP interrupt
;     112    // Place your code here
;     113    PORTF.4=1;
	SBI  0x11,4
;     114    }
;     115 if (OTGINT & 2)
_0xB7:
	LDS  R30,223
	ANDI R30,LOW(0x2)
	BREQ _0xBA
;     116    {
;     117 
;     118    // V-Bus Error interrupt
;     119    // Place your code here
;     120    }
;     121 if (OTGINT & 4)
_0xBA:
	LDS  R30,223
	ANDI R30,LOW(0x4)
	BREQ _0xBB
;     122    {
;     123 
;     124    // B-Connection Error interrupt
;     125    // Place your code here
;     126    }
;     127 if (OTGINT & 8)
_0xBB:
	LDS  R30,223
	ANDI R30,LOW(0x8)
	BREQ _0xBC
;     128    {
;     129    // Role Exchange interrupt
;     130    // Place your code here
;     131    }
;     132 if (OTGINT & 0x10)
_0xBC:
	LDS  R30,223
	ANDI R30,LOW(0x10)
	BREQ _0xBD
;     133    {
;     134    // HNP Error interrupt
;     135    // Place your code here
;     136 
;     137    }
;     138 if (OTGINT & 0x20)
_0xBD:
	LDS  R30,223
	ANDI R30,LOW(0x20)
	BREQ _0xBE
;     139    {
;     140     PORTF.4=1;
	SBI  0x11,4
;     141    // Suspend Time-out Error interrupt
;     142    // Place your code here
;     143 
;     144    }
;     145 OTGINT=0; // Clear the interrupt flags
_0xBE:
	LDI  R30,LOW(0)
	STS  223,R30
;     146 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;     147 
;     148 
;     149 
;     150 // External Interrupt 6 service routine
;     151 interrupt [EXT_INT6] void ext_int6_isr(void)
;     152 {
_ext_int6_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     153 tahometr++;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 3,4,30,31
;     154 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     155 
;     156 // External Interrupt 7 service routine
;     157 interrupt [EXT_INT7] void ext_int7_isr(void)
;     158 {
_ext_int7_isr:
;     159 // Place your code here
;     160 
;     161 }
	RETI
;     162 
;     163 // Declare your global variables here
;     164 
;     165 void main(void)
;     166 {
_main:
;     167 // Declare your local variables here
;     168 
;     169 // Crystal Oscillator division factor: 1
;     170 #pragma optsize-
;     171 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
;     172 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;     173 //#ifdef _OPTIMIZE_SIZE_
;     174 //#pragma optsize+
;     175 //#endif
;     176 
;     177 // Input/Output Ports initialization
;     178 // Port A initialization
;     179 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     180 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;     181 PORTA=0x00;
	OUT  0x2,R30
;     182 DDRA=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1,R30
;     183 
;     184 // Port B initialization
;     185 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     186 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     187 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x5,R30
;     188 DDRB=0x00;
	OUT  0x4,R30
;     189 
;     190 
;     191 // Port C initialization
;     192 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
;     193 // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=T State0=T
;     194 PORTC=0x00;
	OUT  0x8,R30
;     195 DDRC=0xF0;
	LDI  R30,LOW(240)
	OUT  0x7,R30
;     196 
;     197 // Port D initialization
;     198 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
;     199 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
;     200 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     201 DDRD=0x00;
	OUT  0xA,R30
;     202 
;     203 // Port E initialization
;     204 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In
;     205 // State7=T State6=T State5=T State4=T State3=T State2=0 State1=T State0=T
;     206 PORTE=0x00;
	OUT  0xE,R30
;     207 DDRE=0x04;
	LDI  R30,LOW(4)
	OUT  0xD,R30
;     208 
;     209 // Port F initialization
;     210 // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;     211 // State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=0 State0=0
;     212 PORTF=0x00;
	LDI  R30,LOW(0)
	OUT  0x11,R30
;     213 DDRF=0x1F;
	LDI  R30,LOW(31)
	OUT  0x10,R30
;     214 
;     215 // Timer/Counter 0 initialization
;     216 // Clock source: System Clock
;     217 // Clock value: Timer 0 Stopped
;     218 // Mode: Normal top=FFh
;     219 // OC0A output: Disconnected
;     220 // OC0B output: Disconnected
;     221 TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     222 TCCR0B=0x00;
	OUT  0x25,R30
;     223 TCNT0=0x00;
	OUT  0x26,R30
;     224 OCR0A=0x00;
	OUT  0x27,R30
;     225 OCR0B=0x00;
	OUT  0x28,R30
;     226 
;     227 // Timer/Counter 1 initialization
;     228 // Clock source: System Clock
;     229 // Clock value: Timer 1 Stopped
;     230 // Mode: Normal top=FFFFh
;     231 // OC1A output: Discon.
;     232 // OC1B output: Discon.
;     233 // OC1C output: Discon.
;     234 // Noise Canceler: Off
;     235 // Input Capture on Falling Edge
;     236 // Timer 1 Overflow Interrupt: Off
;     237 // Input Capture Interrupt: Off
;     238 // Compare A Match Interrupt: Off
;     239 // Compare B Match Interrupt: Off
;     240 // Compare C Match Interrupt: Off
;     241 TCCR1A=0x00;
	STS  128,R30
;     242 TCCR1B=0x00;
	STS  129,R30
;     243 TCNT1H=0x00;
	STS  133,R30
;     244 TCNT1L=0x00;
	STS  132,R30
;     245 ICR1H=0x00;
	STS  135,R30
;     246 ICR1L=0x00;
	STS  134,R30
;     247 OCR1AH=0x00;
	STS  137,R30
;     248 OCR1AL=0x00;
	STS  136,R30
;     249 OCR1BH=0x00;
	STS  139,R30
;     250 OCR1BL=0x00;
	STS  138,R30
;     251 OCR1CH=0x00;
	STS  141,R30
;     252 OCR1CL=0x00;
	STS  140,R30
;     253 
;     254 // Timer/Counter 2 initialization
;     255 // Clock source: System Clock
;     256 // Clock value: Timer 2 Stopped
;     257 // Mode: Normal top=FFh
;     258 // OC2A output: Disconnected
;     259 // OC2B output: Disconnected
;     260 ASSR=0x00;
	STS  182,R30
;     261 TCCR2A=0x00;
	STS  176,R30
;     262 TCCR2B=0x00;
	STS  177,R30
;     263 TCNT2=0x00;
	STS  178,R30
;     264 OCR2A=0x00;
	STS  179,R30
;     265 OCR2B=0x00;
	STS  180,R30
;     266 
;     267 // Timer/Counter 3 initialization
;     268 // Clock source: System Clock
;     269 // Clock value: Timer 3 Stopped
;     270 // Mode: Normal top=FFFFh
;     271 // Noise Canceler: Off
;     272 // Input Capture on Falling Edge
;     273 // OC3A output: Discon.
;     274 // OC3B output: Discon.
;     275 // OC3C output: Discon.
;     276 // Timer 3 Overflow Interrupt: Off
;     277 // Input Capture Interrupt: Off
;     278 // Compare A Match Interrupt: Off
;     279 // Compare B Match Interrupt: Off
;     280 // Compare C Match Interrupt: Off
;     281 TCCR3A=0x00;
	STS  144,R30
;     282 TCCR3B=0x00;
	STS  145,R30
;     283 TCNT3H=0x00;
	STS  149,R30
;     284 TCNT3L=0x00;
	STS  148,R30
;     285 ICR3H=0x00;
	STS  151,R30
;     286 ICR3L=0x00;
	STS  150,R30
;     287 OCR3AH=0x00;
	STS  153,R30
;     288 OCR3AL=0x00;
	STS  152,R30
;     289 OCR3BH=0x00;
	STS  155,R30
;     290 OCR3BL=0x00;
	STS  154,R30
;     291 OCR3CH=0x00;
	STS  157,R30
;     292 OCR3CL=0x00;
	STS  156,R30
;     293 
;     294 // External Interrupt(s) initialization
;     295 // INT0: Off
;     296 // INT1: Off
;     297 // INT2: Off
;     298 // INT3: Off
;     299 // INT4: Off
;     300 // INT5: Off
;     301 // INT6: On
;     302 // INT6 Mode: Rising Edge
;     303 // INT7: On
;     304 // INT7 Mode: Any change
;     305 EICRA=0x00;
	STS  105,R30
;     306 EICRB=0x70;
	LDI  R30,LOW(112)
	STS  106,R30
;     307 EIMSK=0xC0;
	LDI  R30,LOW(192)
	OUT  0x1D,R30
;     308 EIFR=0xC0;
	OUT  0x1C,R30
;     309 // PCINT0 interrupt: Off
;     310 // PCINT1 interrupt: Off
;     311 // PCINT2 interrupt: Off
;     312 // PCINT3 interrupt: Off
;     313 // PCINT4 interrupt: Off
;     314 // PCINT5 interrupt: Off
;     315 // PCINT6 interrupt: Off
;     316 // PCINT7 interrupt: Off
;     317 PCMSK0=0x00;
	LDI  R30,LOW(0)
	STS  107,R30
;     318 PCICR=0x00;
	STS  104,R30
;     319 
;     320 // Timer/Counter 0 Interrupt(s) initialization
;     321 TIMSK0=0x00;
	STS  110,R30
;     322 // Timer/Counter 1 Interrupt(s) initialization
;     323 TIMSK1=0x00;
	STS  111,R30
;     324 // Timer/Counter 2 Interrupt(s) initialization
;     325 TIMSK2=0x00;
	STS  112,R30
;     326 // Timer/Counter 3 Interrupt(s) initialization
;     327 TIMSK3=0x00;
	STS  113,R30
;     328 
;     329 // Analog Comparator initialization
;     330 // Analog Comparator: Off
;     331 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     332 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     333 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     334 
;     335 // USB Controller initialization
;     336 // USB Mode: Device
;     337 // UID Pin: Off
;     338 // UVCON Pin: Off
;     339 // USB Pad Regulator: Off
;     340 // OTG Pad: Off
;     341 // VBUS Transition interrupt: Off
;     342 // ID Transition interrupt: Off
;     343 USBINT=0; // Clear the interrupt flags
	STS  218,R30
;     344 // SRP interrupt: Off
;     345 // VBUS Error interrupt: Off
;     346 // B-Connection Error interrupt: Off
;     347 // Role Exchange interrupt: Off
;     348 // HNP Error interrupt: Off
;     349 // Suspend Time-out Error interrupt: Off
;     350 OTGIEN=0x00;
	STS  222,R30
;     351 
;     352 OTGINT=0; // Clear the interrupt flags
	STS  223,R30
;     353 // SRP Method: VBUS pulsing
;     354 
;     355 // USB Device mode general registers initialization
;     356 // Low Speed Mode: Off
;     357 
;     358 // Suspend interrupt: Off
;     359 // Start Of Frame interrupt: Off
;     360 // End Of Reset interrupt: Off
;     361 // Wake-up CPU interrupt: Off
;     362 // End Of Resume interrupt: Off
;     363 // Upstream Resume interrupt: Off
;     364 //usb_start_device();
;     365 
;     366 UDINT=0; // Clear the interrupt flags
	STS  225,R30
;     367 // Endpoint 0 selected
;     368 
;     369 UEIENX = 0;
	STS  240,R30
;     370 
;     371  #asm("sei");
	sei
;     372 
;     373 usb_start_device();     // USB
	RCALL _usb_start_device
;     374 //UDIEN = 0b01111101;     // -  "end of reset"  -   !
;     375 init_ep0();
	RCALL _init_ep0
;     376 UEINT = 0;
	LDI  R30,LOW(0)
	STS  244,R30
;     377 
;     378 
;     379 while (!(USBSTA & 0b00000001)==1) {
_0xC1:
	LDS  R30,217
	ANDI R30,LOW(0x1)
	CALL __LNEGB1
	CPI  R30,LOW(0x1)
	BREQ _0xC1
;     380     };                                       //wait for vbus connect
;     381  #asm("sei");
	sei
;     382 
;     383 SREG = SREG | 0b10000000;
	BSET 7
;     384 usb_attach();           //
	RCALL _usb_attach
;     385 Usb_enable_suspend_interrupt();
	RCALL _Usb_enable_suspend_interrupt
;     386 Usb_enable_reset_interrupt();
	RCALL _Usb_enable_reset_interrupt
;     387 
;     388 
;     389 
;     390 while (1)
_0xC4:
;     391      {
;     392  //  if (UEINT) {PORTF.4=1;
;     393 //};
;     394 
;     395     recieve_sof();
	RCALL _recieve_sof
;     396     recieve_reset();
	RCALL _recieve_reset
;     397     recieve_setup();
	RCALL _recieve_setup
;     398 
;     399 
;     400 
;     401 
;     402 
;     403 
;     404 
;     405 
;     406      };
	RJMP _0xC4
;     407 
;     408 
;     409 }
_0xC7:
	RJMP _0xC7


_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
